#include "collisionEvent.h"
#include "simulation.h"


#include "refCounter.cpp"  // for inline defs

void CollisionEvent::doEvent(Simulation *sim) {
	if (o) { //is this a valid collision?
		sim->getCell(p->getOwner()).advanceTo(sim->getTotalTime());
		if (sim->valid(o->getOwner()))
			sim->getCell(o->getOwner()).advanceTo(sim->getTotalTime());
		CellId old_p_owner=p->getOwner();
		CellId old_o_owner=o->getOwner();
		p->setLastCollision(sim->getTotalTime());
		o->setLastCollision(sim->getTotalTime());
        p->doCollision();
		p->findCollision(false);  //false => not deleting old event, because it is this event, and it will be deleted
		o->findCollision(true);   //true => deleting old event
		sim->invalidateCollisionersOf(*p,old_p_owner);
		sim->invalidateCollisionersOf(*o,old_o_owner);
	} else  //invalid collision, only find a new collision partner
		p->findCollision(false);
    
};

void* CollisionEvent::operator new(size_t s) {
    void* r=::operator new(s);
    return r;
};

void CollisionEvent::operator delete(void* p) {
    ::operator delete(p);
};