#ifndef EVENT_H
#define EVENT_H
#include "queueitem.h"
#include "counted.h"
#include "refCounter.hpp"

class Simulation;

class Event:public QueueItem,public RefCounter,public Counted<Event> {
	double time;
public:
    virtual void doEvent(Simulation *sim)=0;
    double getTime() const {return time;}
	Event(double time0):time(time0) {};
    virtual ~Event() {};
};

struct EventKeyExtractor {
    EventKeyExtractor() {}
    typedef double Key;
    inline Key getKey(Event const *e) const {
        return e->getTime();
    }
};

#endif
