#ifndef _LIST_CPP
#define _LIST_CPP

#include <cassert>

template<typename T> class List;
template<typename T> class ListIterator;


template<typename T>
class ListItem {
    friend class List<T>;
    friend class ListIterator<T>;
    private:
        T* next;
};    


template<typename T>
class List {
    friend class ListIterator<T>;
    private:
        T* begin;
        T* getNext(T* x) {
            return x->ListItem<T>::next;
        }; 
        
    public:
        typedef ListIterator<T> iterator;
        List():begin(0) {};
        void insert(T* x) {
            if (begin==0) {
                begin=x;
                x->ListItem<T>::next=0;
            } else {
                T* pom=begin;
                begin=x;
                x->ListItem<T>::next=pom;
            };    
        };
        bool remove(T* x) {
            if (x==begin) {
                begin=getNext(begin);
                return true;
            };    
            T* i;
            for (i=begin;i!=0 && getNext(i)!=x;i=getNext(i)) ;
            if (i!=0) {
                assert(getNext(i)!=0);
                i->ListItem<T>::next=getNext(getNext(i));
                return true;
            };
            return false;
        };
        iterator getIter() {
            return iterator(begin,this);
        };        
};    


template<typename T>
class ListIterator {
    friend class List<T>;
    private:
        T* item;
        List<T> *list;
        T* getNext(T* x) {
            return x->ListItem<T>::next;
        }; 
        ListIterator(T* item0,List<T> *list0):item(item0),list(list0){};
    public:
        ListIterator& operator++() {
            assert(valid()) ;
            item=getNext(item);
            return *this;
        }
        T& operator*() {
            assert(valid());
            return *item;
        }
        T* operator->() {
            assert(valid());
            return item;
        }
        bool valid() {return item!=0;}
                    
        
};


#endif //_LIST_CPP
