/* This does not use Python - for debugging purposes */
#include "simulation.h"

#include <cstdlib>
#include <cmath>
#include <ctime>

Simulation *init_sim() {
	int n=15,maxx=500,maxy=400,maxv=1;
	double radius=3,gravity=0;
	Simulation *sim=new Simulation(n,4,1,maxx,maxy,gravity);
	int rows=int(sqrt(n-1)+1);
	double xspace=double(maxx-radius-1)/rows;
	double yspace=double(maxy-radius-1)/rows;
	double v=1;
	for (int i=0;i<n;i++) {
		double x1=radius+1+(i%rows)*xspace;
		double y1=radius+1+(i/rows)*yspace;
		double vx=(2*rand()/RAND_MAX-1)*maxv;
		double vy=(2*rand()/RAND_MAX-1)*maxv;
		//double alfa=r.random()*2*pi;
		new Particle(sim,x1,y1,vx,vy,radius,1);
	};
	return sim;
}


Simulation *sim;



int main() {
	sim = init_sim( );
	printf( "starting...\n" );
	clock_t t = clock();
	for ( int i = 0;i != 50;i++ ) {
		//        printf("%d\n",i);
		sim->advanceBy( 100.0 );
	}
	; /**/

	{
		clock_t t2 = clock();
		t = t2 - t;
	};
	printf( "Elapsed: %d\n", t );
	//    sim->run(100.0/maxv);
	printf( "Done.\n" );
	scanf( "a" );
};