#include "particle.h"
#include "object.h"

#include <cmath>
#include "particle.h"
#include "simulation.h"
#include <vector>



void Object::doCollisionWith(Particle& p) {
	doCollisionPrivate(p);
};

void Object::doCollisionPrivate(Particle& p) {
	assert(testCollision(p));
	double ax,ay;
	collisionDirection(p,ax,ay);

    // vektory this->v, p.v vyjadrime v suradnicovej sustave danej vektormi a,b
    // kde b je kolme na a
    // a, b su normovane

	Object &p1=*this;
	Particle &p2=p;

	double al=hypot(ax,ay);
	ax/=al; ay/=al; 
	double bx=ay;  
	double by=-ax;    // b je kolme na a
	double v1a=p1.vx*ax + p1.vy*ay;
	double v1b=p1.vx*bx + p1.vy*by;
	double v2a=p2.vx*ax + p2.vy*ay;
	double v2b=p2.vx*bx + p2.vy*by;

	double m1=mass(); double m2=p.mass();

	//zrazka ovplyvnuje iba zlozky v1a, v2a; ratame nove hodnoty
	double v1an,v2an;
	if (m1<infinity && m2<infinity) {
		v1an=(v1a*(m1-m2)+2*v2a*m2)/(m1+m2);
		v2an=(v2a*(m2-m1)+2*v1a*m1)/(m1+m2);
	} else {
		if (m1==infinity) {v1an=v1a; v2an=2*v1a-v2a;}
		else {v1an=2*v2a-v1a; v2an=v2a;}
	}

	v1a=v1an; v2a=v2an;

	p1.vx=v1a*ax+v1b*bx;
	p1.vy=v1a*ay+v1b*by;
	p2.vx=v2a*ax+v2b*bx;
	p2.vy=v2a*ay+v2b*by;
};

void Object::setv(double vx,double vy) {
	this->vx=vx;
	this->vy=vy;
	std::vector<CellId> v;
	getOwners(&v);
	for (int i=0;i<v.size();i++) {
		sim->synchronize(v[i]);
		sim->invalidateCollisionersOf(*this,v[i]);
	};
	findCollision(true);
};
