#ifndef REFCOUNTER_HPP
#define REFCOUNTER_HPP
class RefCounter {
	friend void intrusive_ptr_add_ref(RefCounter*);
	friend void intrusive_ptr_release(RefCounter*);
	mutable int refCount;
	public:
		
		virtual ~RefCounter() {};
     RefCounter():refCount(0) {};
};

void intrusive_ptr_add_ref(RefCounter*);
void intrusive_ptr_release(RefCounter*);

inline void intrusive_ptr_add_ref(RefCounter* p) {
	p->refCount++;
};

inline void intrusive_ptr_release(RefCounter* p) {
	assert(p->refCount > 0);
	if (--p->refCount ==0 )
		delete p;
};


#endif