#ifndef _SAFEVECTOR_H
#define _SAFEVECTOR_H

#include <vector>
#include <cassert>
namespace safe_std {

template <class _Tp, class _Alloc = std::allocator<_Tp> >
class vector:public std::vector<_Tp,_Alloc> 
{
    private:
        typedef std::vector<_Tp,_Alloc> base;
        typedef typename base::reference reference;
    public:
        reference operator[](size_t __n) { 
            assert(__n>=0 && __n<base::size());
            return base::operator[](__n);
        };
};

};
#endif
