#include "precomp.h"
#include <memory>
#include "gas/particle.h"
#include "gas/simulation.h"

using std::auto_ptr;
using namespace boost::python;

void createParticle( Simulation * sim, double x0, double y0, double vx0, double vy0, double r0, double m0 ) {
	Particle *p=new Particle(sim,x0,y0,vx0,vy0,r0,m0);
	sim->addObject(p);
};

void export_particle() {
	/*class_<Particle> ("Particle",init<Simulation*,double,double,double,double,double,double>()[with_custodian_and_ward_postcall<2,1>()]);*/
	/*class_<Particle> ("Particle",init<Simulation*,double,double,double,double,double,double>()
			[return_internal_reference<1>()]);*/
	//class_<Particle>("Particle");
	def("createParticle",createParticle);
	class_<ParticleProxy>("Particle",no_init)
			.def("setv",&ParticleProxy::setv);
};
