#include "precomp.h"
#include <boost/utility.hpp>
#include <memory>
#include "gas/simulation.h"
#include "gas/event.h"
#include "userEvent.h"
#include "gas/wallCreator.h"

using std::auto_ptr;
using namespace boost::python;

void addWall(Simulation& sim,auto_ptr<Wall> x) {
	sim.addObject(x.get());
	x.release();
};

void addParticle(Simulation& sim,auto_ptr<Particle> x) {
	sim.addObject(x.get());
	x.release();
};

/*
void addComposite(Simulation& sim,WallCreator &x) {
	sim.addObject(x.get());
};
*/

void addEvent(Simulation& sim, double time,object fnc) {
    Event *e=new UserEvent(time,fnc);
    sim.addEvent(e);
};

void export_sim()
{
	class_<Simulation,auto_ptr<Simulation>,boost::noncopyable>
			("Simulation",init<int,int,int,double,double,double>())
        .def("addEvent",&addEvent)
		.def("getParticleCount",&Simulation::getParticleCount)
		.def("getParticle",&Simulation::getParticleProxy)
		.def("getTime",&Simulation::getTotalTime);
}

