#include "precomp.h"
#include <boost/utility.hpp>
#include <memory>
#include "gas/wall.h"
#include "gas/wallCreator.h"
#include "gas/simulation.h"

using std::auto_ptr;
using namespace boost::python;

BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(WallCreatorOverloads,addSegmentRel,2,4);

BOOST_PYTHON_MEMBER_FUNCTION_OVERLOADS(StaticWallCreatorOverloads,addSegment,1,3);

void export_wall() {
	enum_<WallType>("WallType")
		.value("wHorizontal",wHorizontal)
		.value("wVertical",wVertical);
	class_<WallCreator,boost::noncopyable>
			("WallCreator",init<Simulation*,double,double,double>())
			.def("addSegmentRel",&WallCreator::addSegmentRel,WallCreatorOverloads());
	class_<StaticWallCreator,boost::noncopyable>
			("StaticWallCreator",init<Simulation*,double,double,WallType>()).def("addSegment",&StaticWallCreator::addSegment,StaticWallCreatorOverloads());
	//class_<Wall,auto_ptr<Wall> >("Wall",init<WallType,double,double,double,double>());
}
